freeslot("MT_BMBOMB", "MT_FLWBOMB", "MT_PANEL",
		 "sfx_kboom", "sfx_puts", "sfx_lift", "sfx_thrw")
//Those are the sounds used for the mod
sfxinfo[sfx_kboom] = {
		caption = "Explosion!",
        singular = false,
        priority = 64,
        flags = SF_X8AWAYSOUND
}
sfxinfo[sfx_lift].caption = "Hyup."
sfxinfo[sfx_thrw].caption = "Twah!"
sfxinfo[sfx_puts].caption = "Mcha."

//This function makes the power-ups spawn(?)
local function spawnPanel(player, enemy)
	local choiceList = {
	S_FIRE,
	S_BOMB
	}
	local panel = P_SpawnMobjFromMobj(enemy, 0,0,0, MT_PANEL)
	panel.ogstate = choiceList[P_RandomRange(1, table.getn(choiceList))]
	panel.state = panel.ogstate
	panel.z = 2*FRACUNIT
	P_SetObjectMomZ(panel, 7*FRACUNIT)
end

//This part is about the bomb. It's reponsible for detecting if the player is pressing the spin button.
addHook("SpinSpecial", function(player)
	
	if player.mo.skin ~= "bomberman" then return false end
	if not player.spintapping then return end
	
	if player.actBom < player.maxBom
	and not player.holding then
		player.actBom = $+1
		S_StartSound(player.mo, sfx_lift)
		local myBomb = P_SpawnMobjFromMobj(player.mo, 0,0,12*FRACUNIT, MT_FLWBOMB)
		P_SetScale(myBomb, 0)
		player.holding = myBomb
		myBomb.owner = player.mo
		player.btimer = 4*TICRATE
		return
	end
	
	if player.holding then
		player.holding.state = S_NULL
		player.holding = nil
		player.btimer = nil
		if(P_IsObjectOnGround(player.mo) and player.speed <= 1*FRACUNIT) then
			S_StartSound(player.mo, sfx_puts)
			local bomb = P_SpawnMobjFromMobj(player.mo, 65*cos(player.mo.angle),65*sin(player.mo.angle),0, MT_BMBOMB)
			bomb.owner = player.mo
			P_SetScale(bomb, bomb.scale/2)
			bomb.timer = 7*TICRATE/2
			bomb.bounced = true
		else
			S_StartSound(player.mo, sfx_thrw)
			local bomb = P_SpawnMobjFromMobj(player.mo, 0,0,64*FRACUNIT, MT_BMBOMB)
			bomb.owner = player.mo
			P_InstaThrust(bomb, player.mo.angle, player.speed+17*FRACUNIT)
			P_SetScale(bomb, bomb.scale/2)
			P_SetObjectMomZ(bomb, player.mo.momz+4*FRACUNIT)
			bomb.timer = 3*TICRATE/2
		end
		return
	end

end, MT_PLAYER)

addHook("MobjThinker", function(flwBomb)
	P_TeleportMove(flwBomb, flwBomb.owner.x, flwBomb.owner.y, flwBomb.owner.z+20*FRACUNIT)
end, MT_FLWBOMB)

addHook("MobjThinker", function(pwrPanel)
	if P_IsObjectOnGround(pwrPanel) and not pwrPanel.boop then
		P_SetObjectMomZ(pwrPanel, 3*FRACUNIT)
		pwrPanel.boop = true
	end
	if pwrPanel.state == S_FLIPC then
		pwrPanel.state = pwrPanel.ogstate
	end
end, MT_PANEL)

addHook("TouchSpecial", function(panel, p)

	if panel.ogstate == S_FIRE
	and p.player.bomPwr < 2*FRACUNIT then
		p.player.bomPwr = $+FRACUNIT/10
		print('DEBUG - My bomb power is now at ' .. p.player.bomPwr)
	end
	
	if panel.ogstate == S_BOMB
	and p.player.maxBom < 5 then
		p.player.maxBom = $+1
		print('DEBUG - I now have ' .. p.player.maxBom .. ' bombs to use')
	end
	
end, MT_PANEL)

addHook("MobjDeath", function(killed, weapon, damagetype)
	if (not weapon) or (not weapon.owner) then return false end
	if weapon.owner.skin ~= "bomberman" then return false end
	if killed.info.flags & MF_SHOOTABLE
	and not (killed.info.flags & MF_MONITOR) then
		if P_RandomRange(1, 12) == 1 then 
			spawnPanel(weapon.owner, killed)
			return false
		end
	end
end)

addHook("MobjThinker", function(bomb)
	if(P_IsObjectOnGround(bomb)) and not bomb.bounced then
		bomb.momx = $/4
		bomb.momy = $/4
		P_SetObjectMomZ(bomb, 4*FRACUNIT)
		bomb.bounced = true
	elseif P_IsObjectOnGround(bomb) and bomb.bounced then
		bomb.momx = 0
		bomb.momy = 0
	end
	
	if bomb.timer and bomb.timer > 0 then
		bomb.timer = $-1
	end
	
	if bomb.timer == 0 then
		bomb.bounced = true
		P_SetScale(bomb, bomb.owner.player.bomPwr)
		bomb.owner.player.actBom = $-1
		bomb.momx = 0
		bomb.momy = 0
		bomb.timer = -1
		local angles = 16
		local angle = 0
		for i = 0, angles - 1 do
			angle = FixedAngle(360*FRACUNIT/angles) * i
			local StillDust = P_SpawnMobjFromMobj(bomb, (87+bomb.scale/FRACUNIT)*cos(angle), (87+bomb.scale/FRACUNIT)*sin(angle), 0, MT_TNTDUST)
			local MoveDust = P_SpawnMobjFromMobj(bomb, (87+bomb.scale/FRACUNIT)*cos(angle), (87+bomb.scale/FRACUNIT)*sin(angle), 0, MT_TNTDUST)
			MoveDust.momx = 6 * cos(angle)
			MoveDust.momy = 6 * sin(angle)
		end
		
		P_RadiusAttack(bomb, bomb, 210*FRACUNIT, 0, true)
		searchBlockmap("objects", function(bomb, found)
			if found.info.flags & MF_MONITOR then
				found.target = bomb.owner
				P_KillMobj(found, bomb, bomb)
			end
			return true
		end, bomb, bomb.x, bomb.x+210*FRACUNIT, bomb.y, bomb.y+210*FRACUNIT)
		
		searchBlockmap("objects", function(bomb, found)
			if found.info.flags & MF_MONITOR then
				found.target = bomb.owner
				P_KillMobj(found, bomb, bomb)
			end
			return true
		end, bomb, bomb.x, bomb.x+210*FRACUNIT, bomb.y, bomb.y+210*FRACUNIT)
		
		if bomb.z - bomb.floorz > 20*FRACUNIT then
			P_SetScale(bomb, bomb.scale/2*3)
			bomb.flags = $ | MF_NOGRAVITY
			bomb.momz = 0
			bomb.state = S_ABOOM1 
		else
			bomb.z = bomb.floorz
			bomb.momz = 0
			P_SetScale(bomb, bomb.scale*2)
			bomb.state = S_BOOM1
		end
		S_StartSound(bomb, sfx_kboom)
		bomb.flags = $ & ~MF_SOLID
	end
end, MT_BMBOMB)

addHook("PlayerThink", function(player)	
	if player.mo.skin ~= "bomberman" then return end
	if player.actBom == nil then player.actBom = 0 end
	if not player.maxBom then player.maxBom = 1 end
	if not player.bomPwr then player.bomPwr = FRACUNIT end
	
	if player.btimer then
		player.btimer = $-1
		if player.btimer == 0 then
			player.holding.state = S_NULL
			player.holding = nil
			local explosion = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_BMBOMB)
			explosion.timer = 0
		end
	end
	
end)

addHook("MobjCollide", function(bomb, collider)
	if collider.player then
		return 
	elseif (not collider.player)
	and collider.flags & MF_SHOOTABLE
	and (bomb.state == S_TICK1 or bomb.state == S_TICK2 or bomb.state == S_TICK3)
	and (bomb.z - collider.z < 75*FRACUNIT) then
		bomb.timer = 0
	end
end, MT_BMBOMB)

addHook("ThinkFrame", function()
	for player in players.iterate do
		if not (player.cmd.buttons & BT_USE) then
			player.spintapready = true
			player.spintapping = false
		elseif player.spintapready then
			player.spintapping = true
			player.spintapready = false
		else
			player.spintapping = false
		end
	end
end)